import 'package:flutter/foundation.dart';

class KeyPair {
  final String publicKey;
  final String secretKey;

  KeyPair(this.publicKey, this.secretKey);
}

class KeyPairs {
  final KeyPair? web;
  final KeyPair? android;
  final KeyPair? ios;

  KeyPairs({this.web, this.android, this.ios});

  KeyPair? get key => kIsWeb
      ? web
      : (defaultTargetPlatform == TargetPlatform.android ? android : ios);

  String? get secretKey => key!.secretKey;

  String? get publicKey => key!.publicKey;

}
