import 'package:apex_flutter_plugin/api/base_request.dart';

class Request extends BaseRequest {
  final int? action;
  final bool isPrivate;

  Request(Map<String, dynamic> params, {this.action, method = Method.POST, this.isPrivate = true})
      : super(params..addAll({if (action != null) 'action': action}),
            method: method);

  factory Request.private(Map<String, dynamic> params, {int? action, method = Method.POST}) {
    return Request(params, action: action, method: method, isPrivate: true);
  }

  factory Request.public(Map<String, dynamic> params, {int? action, method = Method.POST}) {
    return Request(params, action: action, method: method, isPrivate: false);
  }
}
