import 'package:apex_flutter_plugin/api/request.dart';
import 'package:apex_flutter_plugin/server.dart';
import 'package:shared_preferences/shared_preferences.dart';

class LoginRequest extends Request {
  final int countryCode;
  final String username;
  final String password;

  LoginRequest(this.countryCode, this.username, this.password)
      : super({'cc': countryCode, 'username': username, 'password': password},
            isPrivate: true, action: 1002);
}

class LoginAction extends BaseAction {
  final String token;

  LoginAction(int success, String message, this.token)
      : super(success, message) {
    saveCredentials();
  }

  void saveCredentials() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setString('apex_api_token', token);
  }

  factory LoginAction.fromJson(Map<String, dynamic> json) {
    return LoginAction(json['success'], json['message'] ?? '', json['token']);
  }
}
